/*
Receiver auslesen:
http://rcarduino.blogspot.de/2012/01/how-to-read-rc-receiver-with.html

*/

#define THROTTLE_SIGNAL_IN 0 // INTERRUPT 0 = DIGITAL PIN 2 - use the interrupt number in attachInterrupt
#define THROTTLE_SIGNAL_IN_PIN 2 // INTERRUPT 0 = DIGITAL PIN 2 - use the PIN number in digitalRead

// ---------------------------------------------------
// Receiver muss an Digital 2 angeschlossen werden
// ---------------------------------------------------

#define NEUTRAL_THROTTLE 1500 // this is the duration in microseconds of neutral throttle on an electric RC Car

volatile int nThrottleIn = NEUTRAL_THROTTLE; // volatile, we set this in the Interrupt and read it in loop so it must be declared volatile
volatile unsigned long ulStartPeriod = 0; // set in the interrupt
volatile boolean bNewThrottleSignal = false; // set in the interrupt and read in the loop
// we could use nThrottleIn = 0 in loop instead of a separate variable, but using bNewThrottleSignal to indicate we have a new signal 
// is clearer for this first example

// 

// Variabeln für die Lichtsteuerung

int TempSignal = 0; // Speicherort des aktuellen Signals bei Schwellenwertbestimmung
int Signal = 0;    
int rot = 3;     //Anschlusspin des Transistors (5)
int weiss = 6;   //Anschlusspin des Transistors (6)
int SchwellenwertG=1600;    //Wert ab dem es als Gas erkannt wird
int SchwellenwertB=1400;    //Wert ab dem es als Bremsen erkannt wird
int gedimmt=30;          // 255=ungedimmt X=Gedimmter Wert (175)
int TolleranzMax=0;
int TolleranzMin=2500;
int Zustand=0; //0=Bremsen 1=Gas


void LEDinit()
{
   // Transistoren initialisieren
   
   //Blinken als Zeichen, dass Bereit
   int x = 0;
   do
   {
     digitalWrite(weiss, HIGH);  
     analogWrite(rot, 255);
     delay (100);
     digitalWrite(weiss, LOW);  
     analogWrite(rot, 0);
     delay (100);
     x=x+1;
   }while (x<5);
   
   // Normalhelligkeit einstellen
   digitalWrite(weiss, HIGH);   //Weiss immer volle Helligkeit
   analogWrite(rot, gedimmt);
}

void Schwellenwerte()
{ 
  // digitalWrite(weiss, LOW);
  // digitalWrite(rot, LOW);  
  int var=0; //Zähler für loop
  int anz=0; //Anzahl der Messwerte
  Serial.println("Schwellenwerte berechnen");
  delay(500);
  do
  {
     //Serial.println("InLoop");
     if(bNewThrottleSignal) 
     {
       //Serial.println(nThrottleIn);  // Pulslaenge ausgeben
       TempSignal=nThrottleIn;    //neuesSignal einlesen
       bNewThrottleSignal = false;
     }  
     if ((1300<TempSignal)&&(1700>TempSignal))
       {
         if (TempSignal<TolleranzMin)
         {
           TolleranzMin=0;
           TolleranzMin=TempSignal;
           Serial.println("Min: ");
           Serial.println(TolleranzMin);
         }
         if (TempSignal>TolleranzMax)
         {
           TolleranzMax=0;
           TolleranzMax=TempSignal;
           Serial.println("Max: ");
           Serial.println(TolleranzMax);
         }
         var=var+1;
         //Serial.println(var);
       }
     delay(10); //500
     
  }while(var<500);

  SchwellenwertB=(((TolleranzMax+TolleranzMin)/2)-(TolleranzMax-TolleranzMin)); //(((TolleranzMax-TolleranzMin)/2)+15)(TolleranzMax-(Signal/anz))+10
  SchwellenwertG=(SchwellenwertB+(TolleranzMax-TolleranzMin));      //(((TolleranzMax-TolleranzMin)/2)+15)((Signal/anz)-TolleranzMin)-10)
  
  Serial.println("TolleranzMin: ");
  Serial.println(TolleranzMin);
  Serial.println("TolleranzMax: ");
  Serial.println(TolleranzMax);
  
  Serial.println("SchwellenwertG: ");
  Serial.println(SchwellenwertG);
  Serial.println("SchwellenwertB: ");
  Serial.println(SchwellenwertB);
  //delay(10000);
  
  Serial.println("Schwellenwerte berechnet");
}


void setup()
{
  attachInterrupt(THROTTLE_SIGNAL_IN,calcInput,CHANGE);  // Funktion zum Einlesen initialisieren
  Serial.begin(9600);
  pinMode(rot, OUTPUT);
  pinMode(weiss, OUTPUT);
  analogWrite(weiss, gedimmt);
  analogWrite(rot, gedimmt);
  Schwellenwerte(); 
  LEDinit();
  
}

void loop()
{
 // if a new throttle signal has been measured, lets print the value to serial, if not our code could carry on with some other processing
 if(bNewThrottleSignal)
 {

   //Serial.println(nThrottleIn);  // Pulslaenge ausgeben
   Signal=nThrottleIn;
   if ((200<Signal)&&(2800>Signal)) //Prüfen ob Signal gültig
   {
     if (Zustand==1)
     {
       if (Signal < SchwellenwertB)       //Erkennen ob gebremst wird
       {
         analogWrite(rot, 255);
         Serial.println("Bremse"); 
         Zustand=0;
         //Serial.println(Signal); 
         //delay(500);  
       }
     }
     if (Zustand==0)
     {
       if (Signal > SchwellenwertG)       //Erkennen ob Gas gegeben wird        //Hinten gedimmt, vorne voll
       {
         analogWrite(rot, gedimmt);
         Serial.println("Gas");
         Zustand=1;
         //Serial.println(Signal); 
         //delay(500);  
       }
     }
   }
   // set this back to false when we have finished
   // with nThrottleIn, while true, calcInput will not update
   // nThrottleIn
   bNewThrottleSignal = false;
 }
 delay(10); //500
 
 // other processing ... 
}



void calcInput()
{
  // if the pin is high, its the start of an interrupt
  if(digitalRead(THROTTLE_SIGNAL_IN_PIN) == HIGH)
  { 
    // get the time using micros - when our code gets really busy this will become inaccurate, but for the current application its 
    // easy to understand and works very well
    ulStartPeriod = micros();
  }
  else
  {
    // if the pin is low, its the falling edge of the pulse so now we can calculate the pulse duration by subtracting the 
    // start time ulStartPeriod from the current time returned by micros()
    if(ulStartPeriod && (bNewThrottleSignal == false))
    {
      nThrottleIn = (int)(micros() - ulStartPeriod);
      ulStartPeriod = 0;

      // tell loop we have a new signal on the throttle channel
      // we will not update nThrottleIn until loop sets
      // bNewThrottleSignal back to false
      bNewThrottleSignal = true;
    }
  }
}
